#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdbool.h>
#include "tmpfile.h"

bool add_random(char* s, unsigned int nbytes) {
   static int rfd = -1;
   if (rfd < 0) {
      rfd = open("/dev/urandom", O_RDONLY);
      if (rfd < 0) return false;
   }
   return read(rfd, s, nbytes) == nbytes;
}

int create_tmpfile() {
   char tmpfile[] = "/tmp/TMP.XXXX";
   char* p = strchr(tmpfile, 'X');
   unsigned int tries = 0;
   int fd;
   do {
      if (!add_random(p, 4)) return -1;
   } while ((fd = open(tmpfile, O_RDWR|O_EXCL|O_CREAT, 0)) < 0 && ++tries < 10);
   if (fd < 0) return -1;
   unlink(tmpfile);
   return fd;
}
