#include <stdlib.h>
#include <unistd.h>
#include "worker.h"
#include "primes.h"

void find_primes(int outfd, /* print found primes using this fd */
	 mpz_t start_interval,
	 mpz_t end_interval,
	 unsigned int k,         // size of prime constellation
	 unsigned int offsets[]) { // k-1 offsets
   mpz_t first_prime; mpz_init(first_prime);
   while (search_prime_constellation(start_interval, end_interval,
	    k, offsets, first_prime)) {
      char* s = mpz_get_str(0, 10, first_prime);
      char* t = s;
      while (*t) ++t; // locate terminating nullbyte
      *t++ = '\n'; // replace nullbyte by line terminator
      if (write(outfd, s, t - s) < 0) return; // abort
      free(s);
      mpz_set(start_interval, first_prime);
      mpz_add_ui(start_interval, start_interval, 1);
   }
}
